
/*---------------------------------------------------------------------------*/
/* replication.cpp                                                             */
/* copyright (c) innovaphone 2016                                            */
/*                                                                           */
/*---------------------------------------------------------------------------*/

#include "platform/platform.h"
#include "common/build/release.h"
#include "common/os/iomux.h"
#include "common/interface/webserver_plugin.h"
#include "common/interface/database.h"
#include "common/interface/task.h"
#include "common/interface/httpfile.h"
#include "common/interface/socket.h"
#include "common/interface/json_api.h"
#include "common/interface/replication.h"
#include "common/lib/appservice.h"
#include "common/lib/appwebsocket.h"
#include "common/lib/tasks_postgresql.h"
#include "replication/replication.h"

int main(int argc, char *argv[])
{
    class IIoMux * iomux = IIoMux::Create();
	ISocketProvider * localSocketProvider = CreateLocalSocketProvider();
    IWebserverPluginProvider * webserverPluginProvider = CreateWebserverPluginProvider();
    IDatabaseProvider * databaseProvider = CreatePostgreSQLDatabaseProvider();

    AppServiceArgs  serviceArgs;
    serviceArgs.serviceID = "replication";
    serviceArgs.Parse(argc, argv);
    AppInstanceArgs instanceArgs;
    instanceArgs.appName = "replication";
    instanceArgs.appDomain = "example.com";
    instanceArgs.appPassword = "pwd";
    instanceArgs.webserver = "/var/run/webserver/webserver";
    instanceArgs.webserverPath = "/replication";
    instanceArgs.dbHost = "";
    instanceArgs.dbName = "replication";
    instanceArgs.dbUser = "replication";
    instanceArgs.dbPassword = "pwd";
    instanceArgs.Parse(argc, argv);
	
    ReplicationService * service = new ReplicationService(iomux, localSocketProvider, webserverPluginProvider, databaseProvider, &serviceArgs);
    if (!serviceArgs.manager) service->AppStart(&instanceArgs);
    iomux->Run();

    delete service;
	delete localSocketProvider;
    delete webserverPluginProvider;
    delete databaseProvider;
    delete iomux;
    delete debug;
    
    return 0;
}
